
///////////// ЧАСЫ-ШКАЛЫ НА 3 ИНДИКАТОРАХ
#include <OLED_I2C.h>
OLED  myOLED(SDA, SCL);
#define disp_1 12 // управляющие дисплееями выводы 
#define disp_2 11
#define disp_3 10
/////////////
#include <iarduino_RTC.h>
iarduino_RTC time(RTC_DS3231);
//SDA - A4 //SCL - A5 //ПОДКЛЮЧЕНИЕ ВЫВОДОВ МОДУЛЯ ВРЕМЕНИ
extern uint8_t RusFont[];
int t = 222; // пауза между считываниями данных
bool PUSK = true;//флаг для начального включения-обновления данных всех экранов

void setup()
{
  ////// подключение всех дисплеев
  pinMode(disp_1, OUTPUT);
  digitalWrite(disp_1, HIGH);
  myOLED.begin();
  digitalWrite(disp_1, LOW);
  delay(50);
  //////
  pinMode(disp_2, OUTPUT);
  digitalWrite(disp_2, HIGH);
  myOLED.begin();
  digitalWrite(disp_2, LOW);
  delay(50);
  ////////
  pinMode(disp_3, OUTPUT);
  digitalWrite(disp_3, HIGH);
  myOLED.begin();
  digitalWrite(disp_3, LOW);
  delay(50);
  ////////
  myOLED.setFont(RusFont);
  myOLED.invert(0);//инверсия цвета
  time.begin();
  ////////начальная установка часов////////
  //time.settime(0,58,18,20,8,19,2);  // 0  сек, 58 мин, 18 час, 20, АВГУСТА, 2019 года, ВТОРНИК (раскомментить, выставить желаемое, загрузить скетч, закомментить,загрузить скетч)
  /////////////
  fun_();//выставляем показания на экраны
  PUSK = false;
  ///////////
}

void loop()
{
  fun_();//выставляем показания на экраны
  delay(t);
}
////////////////////////////
////////////////////////////
///////////////////////////
void dis_1() { //функции обновления изображений на экранах
  digitalWrite(disp_1, HIGH); myOLED.update(); digitalWrite(disp_1, LOW); myOLED.clrScr(); // очищаем дисплей
}
void dis_2() {
  digitalWrite(disp_2, HIGH); myOLED.update(); digitalWrite(disp_2, LOW); myOLED.clrScr(); // очищаем дисплей
}
void dis_3() {
  digitalWrite(disp_3, HIGH); myOLED.update(); digitalWrite(disp_3, LOW); myOLED.clrScr(); // очищаем дисплей
}
/////////////////////////
/////////////////////////
///////////////////////// функция рисования стрелки ////////////////////////////////
void primitiv_1(int x, int y, int r1, int r2, int n, float rotor) { //x,y координаты центра фигуры; r1,r2 радиусы зубцов и впадин фигуры; n число зубцов;rotor угол поворота фигуры
  for (float i = 0 + rotor; i < 1 * PI + rotor; i = i + 2 * PI / n) {
    myOLED.drawLine(x + r1 * cos(i) , y + r1 * sin(i), x + r2 * cos(i + PI / n) , y + r2 * sin(i + PI / n) );
    myOLED.drawLine(x + r2 * cos(i + PI / n) , y + r2 * sin(i + PI / n), x + r1 * cos(i + 2 * PI / n) , y + r1 * sin(i + 2 * PI / n));
  }
}
///////////////////////// функция рисования прибора-шкалы //////////////////////////
void pribor_ (String str, int x1, int y1, int n1, float rotor1, float pologenie) { //str название шкалы; x1,y1 координаты положения центра; n1 число делений; rotor1 начальный угол положения стрелки; pologenie угол указанного положения стрелки
  for (int i = 22; i < 29; i++) {
    primitiv_1(x1, y1, 7, i, 2, (2 * PI / n1)*pologenie + rotor1); //стрелка
  }
  for (int i = 6; i < 9; i++) {
    myOLED.drawCircle(x1, y1, i);
  }

  myOLED.drawCircle(x1 - 1, y1 - 1, 30); //шкала
  for (float i = 0; i < 2 * PI; i = i + 2 * PI / n1) {
    if (i >= PI / 2 && i < PI / 2 + 2 * PI / n1) {
      myOLED.drawLine(x1 - 15 * cos(i), y1 - 15 * sin(i), x1 - 30 * cos(i), y1 - 30 * sin(i));
    } else {
      myOLED.drawLine(x1 - 25 * cos(i), y1 - 25 * sin(i), x1 - 30 * cos(i), y1 - 30 * sin(i));
    }
  }
  myOLED.print(str, x1 - 10, y1 + 15); // название шкалы
}
////////////////////// функция выставления значений времени по шкалам
void fun_() {
  time.gettime();//
  pribor_("CTR", 31, 32, 12, -PI, time.seconds / 5.0); // шкала секунд
  pribor_("LTY", 97, 32, 7, -PI + 0.2, time.weekday); //шкала дня недели
  dis_2(); //обработка и обновление данных на 2 индикаторе
  if (time.seconds == 0 || PUSK) {
    pribor_("XFC", 31, 32, 12, -PI, time.hours + time.minutes / 60.0); //шкала часов
    pribor_("VBY", 97, 32, 12, -PI, time.minutes / 5.0 + time.seconds / 300.0); // шкала минут
    dis_3(); //обработка и обновление данных на 3 индикаторе
  }
  if ((time.Hours == 0 && time.minutes == 0 && time.seconds == 0) || PUSK) {
    pribor_("XBC", 31, 32, 31, -PI, time.day); //шкала числа месяца
    pribor_("VTC", 97, 32, 12, -PI, time.month); // шкала месяца года
    dis_1(); //обработка и обновление данных на 1 индикаторе
  }
}

